       ID DIVISION.
       PROGRAM-ID. WITHXA.
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
           EXEC SQL BEGIN DECLARE SECTION END-EXEC.
       01  EMP-NAME                 PIC X(10).
       01  EMP-NUMBER               PIC S9(4) COMP-5 VALUE ZERO.
           EXEC SQL END DECLARE SECTION END-EXEC.
           EXEC SQL INCLUDE SQLCA END-EXEC.
       01 TABLE-ITEM PIC X OCCURS 10 TIMES INDEXED BY IDX.
       01 TMP-ENAME                 PIC X(10).
       LINKAGE SECTION.
       01  L-EMP-NAME               PIC X(10).
       01  L-EMP-NUMBER             PIC S9(4) COMP-5.
       01  L-COMMIT-OR-ROLLBACK     PIC X.
       01  L-LOG-MSG                PIC X(80).
       PROCEDURE DIVISION USING L-EMP-NAME L-EMP-NUMBER
                                L-COMMIT-OR-ROLLBACK L-LOG-MSG.
       BEGIN-PGM.
           PERFORM OBTAIN-ENAME.
           PERFORM UPDATE-ENAME.
           PERFORM COMMIT-OR-ROLLBACK.
           GOBACK.

       OBTAIN-ENAME.
           MOVE L-EMP-NUMBER TO EMP-NUMBER.
           EXEC SQL
               SELECT ENAME INTO :EMP-NAME FROM EMP
               WHERE EMPNO = :EMP-NUMBER
           END-EXEC.
           EXIT.
           MOVE EMP-NAME TO TMP-ENAME.
           EXIT.

       UPDATE-ENAME.
           MOVE L-EMP-NAME TO EMP-NAME.
           EXEC SQL
               UPDATE EMP SET ENAME = :EMP-NAME
               WHERE EMPNO = :EMP-NUMBER
           END-EXEC.
           EXIT.
           STRING "ENAME CHANGED FROM " TMP-ENAME "TO " EMP-NAME
           INTO L-LOG-MSG.
           EXIT.

       COMMIT-OR-ROLLBACK.
           IF L-COMMIT-OR-ROLLBACK = 'R'
             SET IDX TO 11
             MOVE SPACE TO TABLE-ITEM(IDX)
           END-IF.
           EXIT.
